select
an.numero,
(select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue,
rep.data,tp.descricao as tipo,
pes.nome as inseminador,
(case when (rep.condicaoia = 'I') then 'Protocolo IAFT' when (rep.condicaoia = 'N') then 'Normal' when (rep.condicaoia = 'P') then 'Prostaglandina' else null end) as condicao_ia,
(case when (rep.condicaoia = 'I') then pro.descricao else null end) as protocolo,
(case when (an.cdcategoriainicial = 7 and an.cdcategoria = 7) then 'Vaca' when (an.cdcategoriainicial <> 7 and an.cdcategoria = 7 and not exists (select * from lactacao lac where dtinicio < rep.data and lac.cdanimal = an.cdanimal)) then 'Novilha'
    when (an.cdcategoria = 6) then 'Novilha' else 'Vaca' end) as categoria_cobertura,
tou.numero as reprodutor,
maeemb.numero as doadora,
(case when (prox.diagnostico='P') then 'P' when (prox.cdtiporeproducao in (1,2,3)) then 'N' when (prox.diagnostico='N') then 'N' when (prox.cio in ('1','2')) then 'N' else null end) as diagnostico,
(case when (prox.cdtiporeproducao=4 and prox.diagnostico='P') then prox.dtpartoprovavel else null end) as parto_previsto,
pp.data as parto_real,
tpar.descricao as tipoparto,
(case when (pp.sexocria1 is not null) then pp.sexocria1 else cria.sexo end) as sexo_cria,
(case when (prox.cdtiporeproducao=4 and prox.diagnostico='P' and not exists (select * from reproducao ref4 where ref4.cdanimal=rep.cdanimal and ref4.data>rep.data and (cdtiporeproducao in (1,2,3,7) or (cdtiporeproducao=4 and diagnostico='N') or (cdtiporeproducao=4 and cio in ('1','2'))))) then 'Aberto'
when (prox.cdtiporeproducao=4 and prox.diagnostico='P' and exists (select * from reproducao ref4 where ref4.cdanimal=rep.cdanimal and ref4.data>rep.data and pp.data is null and (cdtiporeproducao in (1,2,3,7) or (cdtiporeproducao=4 and diagnostico='N') or (cdtiporeproducao=4 and cio in ('1','2'))))) then 'Perdeu a gestao'
else null end) as situacao
from
animal an join reproducao rep on an.cdanimal=rep.cdanimal
left join tiporeproducao tp on rep.cdtiporeproducao=tp.cdtiporeproducao
left join pessoa pes on pes.cdpessoa = rep.cdpessoa
left join protocoloiatf pro on pro.cdprotocoloiatf = rep.cdprotocoloiatf
left join animal tou on rep.cdreprodutor=tou.cdanimal
left join animal emb on rep.cdembriao=emb.cdanimal
left join animal maeemb on emb.cdmae=maeemb.cdanimal
left join reproducao prox on prox.cdreproducao=
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal=rep.cdanimal
        and re.data>rep.data and
            ((re.cdtiporeproducao=4 and diagnostico is not null) or
                (re.cdtiporeproducao=4 and cio in (1,2)) or (re.cdtiporeproducao in (1,2,3)))order by re.data)
left join reproducao pp on pp.cdreproducao=
    (select first 1 re.cdreproducao from reproducao re
        where re.cdanimal=rep.cdanimal and re.data>rep.data and re.cdtiporeproducao=7
        and not exists (select * from reproducao ree where ree.cdanimal=re.cdanimal and ree.data>rep.data
                        and ree.data<re.data and ((ree.cdtiporeproducao in (1,2,3)
                        or (ree.diagnostico='N') or (ree.cio in (1,2))))))
left join tiporeproducao tp2 on prox.cdtiporeproducao=tp2.cdtiporeproducao
left join tipoparto tpar on pp.cdtipoparto=tpar.cdtipoparto
left join animal cria on cria.cdreproducao=pp.cdreproducao
where
rep.cdtiporeproducao in (1,2,3) and
rep.data between '2011-01-01' and '2011-01-31'
order by
an.numero


